package com.FranckBarbier.Java._Banking_system._ATM;

public class User_interface implements javafx.fxml.Initializable {

    private static String _Choose_operation_kind = "";

    static {
        for (int i = 0; i < Operation._Literals.length; i++) {
            _Choose_operation_kind += i + ".: " + Operation._Literals[i] + "\n";
        }
    }
    private final static javafx.scene.image.Image _Any_device = new javafx.scene.image.Image(User_interface.class.getResource("img/Any_device.png").toExternalForm());
    private final static javafx.scene.image.Image _Activate_cash_dispenser = new javafx.scene.image.Image(User_interface.class.getResource("img/Activate_cash_dispenser.png").toExternalForm());
    private final static javafx.scene.image.Image _Activate_deposit_drawer = new javafx.scene.image.Image(User_interface.class.getResource("img/Activate_deposit_drawer.png").toExternalForm());
    private final static javafx.scene.image.Image _Activate_receipt_printer = new javafx.scene.image.Image(User_interface.class.getResource("img/Activate_receipt_printer.png").toExternalForm());
    private final static javafx.scene.layout.Background _Card_inside = new javafx.scene.layout.Background(new javafx.scene.layout.BackgroundImage(new javafx.scene.image.Image(User_interface.class.getResource("img/Card_inside.png").toExternalForm()), javafx.scene.layout.BackgroundRepeat.NO_REPEAT, javafx.scene.layout.BackgroundRepeat.NO_REPEAT, javafx.scene.layout.BackgroundPosition.CENTER, javafx.scene.layout.BackgroundSize.DEFAULT));
    private final static javafx.scene.layout.Background _Card_outside = new javafx.scene.layout.Background(new javafx.scene.layout.BackgroundImage(new javafx.scene.image.Image(User_interface.class.getResource("img/Card_outside.png").toExternalForm()), javafx.scene.layout.BackgroundRepeat.NO_REPEAT, javafx.scene.layout.BackgroundRepeat.NO_REPEAT, javafx.scene.layout.BackgroundPosition.CENTER, javafx.scene.layout.BackgroundSize.DEFAULT));

    private final static javafx.scene.media.Media _Deliver_cash = new javafx.scene.media.Media(User_interface.class.getResource("sound/Deliver_cash.mp3").toString());
    private final static javafx.scene.media.Media _Deliver_receipt = new javafx.scene.media.Media(User_interface.class.getResource("sound/Deliver_receipt.mp3").toString());
    private final static javafx.scene.media.Media _Key_pressed = new javafx.scene.media.Media(User_interface.class.getResource("sound/Key_pressed.mp3").toString());

    @javafx.fxml.FXML
    private javafx.scene.control.TextArea _display_area;
    @javafx.fxml.FXML
    private javafx.scene.control.TextArea _current_state;
    @javafx.fxml.FXML
    private javafx.scene.control.Button _card_inserted_button;
    @javafx.fxml.FXML
    private javafx.scene.control.Button _card_taken_button;
    @javafx.fxml.FXML
    private javafx.scene.control.ProgressIndicator _progress_indicator;
    @javafx.fxml.FXML
    private javafx.scene.image.ImageView _cash_dispenser_image;
    @javafx.fxml.FXML
    private javafx.scene.image.ImageView _deposit_drawer_image;
    @javafx.fxml.FXML
    private javafx.scene.image.ImageView _receipt_printer_image;

    protected static final byte _Amount_length = 4;
    protected static final byte _Password_length = 4;

    protected StringBuffer _amount = new StringBuffer(_Amount_length);
    protected StringBuffer _password = new StringBuffer(_Password_length);

    private ATM _atm;
    private com.FranckBarbier.Java._Banking_system._Consortium.Banking_system_database _database;

    public User_interface() throws Exception {
        _database = new com.FranckBarbier.Java._Banking_system._Consortium.Banking_system_database();
    }

    @Override
    public void initialize(java.net.URL url, java.util.ResourceBundle rb) {
        _display_area.setWrapText(true);
        _cash_dispenser_image.setImage(_Any_device);
        _deposit_drawer_image.setImage(_Any_device);
        _receipt_printer_image.setImage(_Any_device);
    }

    public void add_atm(ATM atm) {
        _atm = atm;
        _current_state.setText(_atm.async_current_state());
    }

    @javafx.fxml.FXML
    private void abort(javafx.event.ActionEvent event) {
        new javafx.scene.media.MediaPlayer(_Key_pressed).play();
        try {
            _atm.abort();
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
    }

    @javafx.fxml.FXML
    private void card_inserted(javafx.event.ActionEvent event) throws Exception {
        java.util.List<String> available_cards = _database.cards();
        if (available_cards != null && !available_cards.isEmpty()) {
            javafx.scene.control.ChoiceDialog<String> dialog = new javafx.scene.control.ChoiceDialog<>(available_cards.get(0), available_cards);
            dialog.setTitle("Banking system");
            dialog.setHeaderText("Available cards in database");
            dialog.setContentText("Please choose card and press -OK-");
            java.util.Optional<String> value = dialog.showAndWait();
            if (value.isPresent()) {
                card_inserted(_database.card(value.get()));
            } else {
                javafx.scene.control.Alert alert = new javafx.scene.control.Alert(javafx.scene.control.Alert.AlertType.WARNING);
                alert.setTitle("Banking system");
                alert.setHeaderText("No available cards has been chosen!");
                alert.show();
            }
        } else {
            javafx.scene.control.Alert alert = new javafx.scene.control.Alert(javafx.scene.control.Alert.AlertType.WARNING);
            alert.setTitle("Banking system");
            alert.setHeaderText("No available cards in database!");
            alert.show();
        }
    }

    private void card_inserted(com.FranckBarbier.Java._Banking_system._Consortium.Plastic_card card) {
        _card_inserted_button.setDisable(true);
        _card_inserted_button.setBackground(_Card_inside);
        _progress_indicator.setVisible(true);
        try {
            _atm.card_reader().card_inserted(card);
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
    }

    @javafx.fxml.FXML
    private void card_taken(javafx.event.ActionEvent event) {
        _card_taken_button.setDisable(true);
        try {
            _atm.card_reader().card_taken();
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
    }

    @javafx.fxml.FXML
    private void continuation(javafx.event.ActionEvent event) {
        new javafx.scene.media.MediaPlayer(_Key_pressed).play();
        try {
            _atm.continuation();
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
    }

    @javafx.fxml.FXML
    private void enter(javafx.event.ActionEvent event) {
        new javafx.scene.media.MediaPlayer(_Key_pressed).play();
        try {
            try {
                if (_atm.amount_choice()) {
                    _atm.amount_chosen((new Integer(_amount.toString())).intValue());
                }
            } catch (NumberFormatException nfe) {
                _display_area.setText(nfe.getMessage());
            }
            if (_atm.password_request()) {
                _atm.password_entered(_password.toString());
            }
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
    }

    @javafx.fxml.FXML
    private void termination(javafx.event.ActionEvent event) {
        new javafx.scene.media.MediaPlayer(_Key_pressed).play();
        try {
            _atm.termination();
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
    }

    @javafx.fxml.FXML
    private void on_backspace(javafx.event.ActionEvent event) {
        new javafx.scene.media.MediaPlayer(_Key_pressed).play();
        if (_atm.amount_choice()) {
            if (_amount.length() > 0) {
                _amount.deleteCharAt(_amount.length() - 1);
                StringBuffer screen = new StringBuffer(_display_area.getText());
                if (screen.length() > 0) {
                    screen.deleteCharAt(screen.length() - 1);
                }
                _display_area.setText(screen.toString());
            }
        }
        if (_atm.password_request()) {
            if (_password.length() > 0) {
                _password.deleteCharAt(_password.length() - 1);
                StringBuffer screen = new StringBuffer(_display_area.getText());
                if (screen.length() > 0) {
                    screen.deleteCharAt(screen.length() - 1);
                }
                _display_area.setText(screen.toString());
            }
        }
    }

    @javafx.fxml.FXML
    private void on_key_0(javafx.event.ActionEvent event) {
        new javafx.scene.media.MediaPlayer(_Key_pressed).play();
        try {
            if (_atm.account_choice()) {
                _atm.account_chosen((com.FranckBarbier.Java._Banking_system._Consortium.Account) _atm._portfolio.account().toArray()[0]);
            }
        } catch (ArrayIndexOutOfBoundsException aioobe) {
            _display_area.setText(aioobe.getMessage());
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
        if (_atm.amount_choice()) {
            if (_amount.length() < _Amount_length) {
                _amount.append('0');
                _display_area.setText(_display_area.getText() + '0');
            }
        }
        try {
            if (_atm.operation_kind_choice()) {
                _atm.operation_kind_chosen(Operation._Kinds[0]);
            }
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
        if (_atm.password_request()) {
            if (_password.length() < _Password_length) {
                _password.append('0');
                _display_area.setText(_display_area.getText() + "*");
            }
        }
    }

    @javafx.fxml.FXML
    private void on_key_9(javafx.event.ActionEvent event) {
        new javafx.scene.media.MediaPlayer(_Key_pressed).play();
        try {
            if (_atm.account_choice()) {
                _atm.account_chosen((com.FranckBarbier.Java._Banking_system._Consortium.Account) _atm._portfolio.account().toArray()[9]);
            }
        } catch (ArrayIndexOutOfBoundsException aioobe) {
            _display_area.setText(aioobe.getMessage());
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
        if (_atm.amount_choice()) {
            if (_amount.length() < _Amount_length) {
                _amount.append('9');
                _display_area.setText(_display_area.getText() + '9');
            }
        }
        if (_atm.password_request()) {
            if (_password.length() < _Password_length) {
                _password.append('9');
                _display_area.setText(_display_area.getText() + "*");
            }
        }
    }

    @javafx.fxml.FXML
    private void on_key_8(javafx.event.ActionEvent event) {
        new javafx.scene.media.MediaPlayer(_Key_pressed).play();
        try {
            if (_atm.account_choice()) {
                _atm.account_chosen((com.FranckBarbier.Java._Banking_system._Consortium.Account) _atm._portfolio.account().toArray()[8]);
            }
        } catch (ArrayIndexOutOfBoundsException aioobe) {
            _display_area.setText(aioobe.getMessage());
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
        if (_atm.amount_choice()) {
            if (_amount.length() < _Amount_length) {
                _amount.append('8');
                _display_area.setText(_display_area.getText() + '8');
            }
        }
        if (_atm.password_request()) {
            if (_password.length() < _Password_length) {
                _password.append('8');
                _display_area.setText(_display_area.getText() + "*");
            }
        }
    }

    @javafx.fxml.FXML
    private void on_key_7(javafx.event.ActionEvent event) {
        new javafx.scene.media.MediaPlayer(_Key_pressed).play();
        try {
            if (_atm.account_choice()) {
                _atm.account_chosen((com.FranckBarbier.Java._Banking_system._Consortium.Account) _atm._portfolio.account().toArray()[7]);
            }
        } catch (ArrayIndexOutOfBoundsException aioobe) {
            _display_area.setText(aioobe.getMessage());
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
        if (_atm.amount_choice()) {
            if (_amount.length() < _Amount_length) {
                _amount.append('7');
                _display_area.setText(_display_area.getText() + '7');
            }
        }
        if (_atm.password_request()) {
            if (_password.length() < _Password_length) {
                _password.append('7');
                _display_area.setText(_display_area.getText() + "*");
            }
        }
    }

    @javafx.fxml.FXML
    private void on_key_6(javafx.event.ActionEvent event) {
        new javafx.scene.media.MediaPlayer(_Key_pressed).play();
        try {
            if (_atm.account_choice()) {
                _atm.account_chosen((com.FranckBarbier.Java._Banking_system._Consortium.Account) _atm._portfolio.account().toArray()[6]);
            }
        } catch (ArrayIndexOutOfBoundsException aioobe) {
            _display_area.setText(aioobe.getMessage());
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
        if (_atm.amount_choice()) {
            if (_amount.length() < _Amount_length) {
                _amount.append('6');
                _display_area.setText(_display_area.getText() + '6');
            }
        }
        if (_atm.password_request()) {
            if (_password.length() < _Password_length) {
                _password.append('6');
                _display_area.setText(_display_area.getText() + "*");
            }
        }
    }

    @javafx.fxml.FXML
    private void on_key_5(javafx.event.ActionEvent event) {
        new javafx.scene.media.MediaPlayer(_Key_pressed).play();
        try {
            if (_atm.account_choice()) {
                _atm.account_chosen((com.FranckBarbier.Java._Banking_system._Consortium.Account) _atm._portfolio.account().toArray()[5]);
            }
        } catch (ArrayIndexOutOfBoundsException aioobe) {
            _display_area.setText(aioobe.getMessage());
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
        if (_atm.amount_choice()) {
            if (_amount.length() < _Amount_length) {
                _amount.append('5');
                _display_area.setText(_display_area.getText() + '5');
            }
        }
        if (_atm.password_request()) {
            if (_password.length() < _Password_length) {
                _password.append('5');
                _display_area.setText(_display_area.getText() + "*");
            }
        }
    }

    @javafx.fxml.FXML
    private void on_key_4(javafx.event.ActionEvent event) {
        new javafx.scene.media.MediaPlayer(_Key_pressed).play();
        try {
            if (_atm.account_choice()) {
                _atm.account_chosen((com.FranckBarbier.Java._Banking_system._Consortium.Account) _atm._portfolio.account().toArray()[4]);
            }
        } catch (ArrayIndexOutOfBoundsException aioobe) {
            _display_area.setText(aioobe.getMessage());
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
        if (_atm.amount_choice()) {
            if (_amount.length() < _Amount_length) {
                _amount.append('4');
                _display_area.setText(_display_area.getText() + '4');
            }
        }
        if (_atm.password_request()) {
            if (_password.length() < _Password_length) {
                _password.append('4');
                _display_area.setText(_display_area.getText() + "*");
            }
        }
    }

    @javafx.fxml.FXML
    private void on_key_3(javafx.event.ActionEvent event) {
        new javafx.scene.media.MediaPlayer(_Key_pressed).play();
        try {
            if (_atm.account_choice()) {
                _atm.account_chosen((com.FranckBarbier.Java._Banking_system._Consortium.Account) _atm._portfolio.account().toArray()[3]);
            }
        } catch (ArrayIndexOutOfBoundsException aioobe) {
            _display_area.setText(aioobe.getMessage());
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
        if (_atm.amount_choice()) {
            if (_amount.length() < _Amount_length) {
                _amount.append('3');
                _display_area.setText(_display_area.getText() + '3');
            }
        }
        if (_atm.password_request()) {
            if (_password.length() < _Password_length) {
                _password.append('3');
                _display_area.setText(_display_area.getText() + "*");
            }
        }
        try {
            if (_atm.operation_kind_choice()) {
                _atm.operation_kind_chosen(Operation._Kinds[3]);
                _current_state.setText(_atm.async_current_state());
            }
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
    }

    @javafx.fxml.FXML
    private void on_key_2(javafx.event.ActionEvent event) {
        new javafx.scene.media.MediaPlayer(_Key_pressed).play();
        try {
            if (_atm.account_choice()) {
                _atm.account_chosen((com.FranckBarbier.Java._Banking_system._Consortium.Account) _atm._portfolio.account().toArray()[2]);
            }
        } catch (ArrayIndexOutOfBoundsException aioobe) {
            _display_area.setText(aioobe.getMessage());
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
        if (_atm.amount_choice()) {
            if (_amount.length() < _Amount_length) {
                _amount.append('2');
                _display_area.setText(_display_area.getText() + '2');
            }
        }
        if (_atm.password_request()) {
            if (_password.length() < _Password_length) {
                _password.append('2');
                _display_area.setText(_display_area.getText() + "*");
            }
        }
        try {
            if (_atm.operation_kind_choice()) {
                _atm.operation_kind_chosen(Operation._Kinds[2]);
            }
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
    }

    @javafx.fxml.FXML
    private void on_key_1(javafx.event.ActionEvent event) {
        new javafx.scene.media.MediaPlayer(_Key_pressed).play();
        try {
            if (_atm.account_choice()) {
                _atm.account_chosen((com.FranckBarbier.Java._Banking_system._Consortium.Account) _atm._portfolio.account().toArray()[1]);
            }
        } catch (ArrayIndexOutOfBoundsException aioobe) {
            _display_area.setText(aioobe.getMessage());
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
        if (_atm.amount_choice()) {
            if (_amount.length() < _Amount_length) {
                _amount.append('1');
                _display_area.setText(_display_area.getText() + '1');
            }
        }
        try {
            if (_atm.operation_kind_choice()) {
                _atm.operation_kind_chosen(Operation._Kinds[1]);
            }
        } catch (com.pauware.pauware_engine._Exception.Statechart_exception se) {
            _display_area.setText(se.getMessage());
        }
        if (_atm.password_request()) {
            if (_password.length() < _Password_length) {
                _password.append('1');
                _display_area.setText(_display_area.getText() + "*");
            }
        }
    }

    private void exitForm(javafx.event.ActionEvent event) {
        try {
            _atm.stop();
        } catch (Throwable t) {
            t.printStackTrace();
        }
        System.exit(0);
    }

    public void activate_cash_dispenser() {
        new javafx.scene.media.MediaPlayer(_Deliver_cash).play();
        javafx.application.Platform.runLater(() -> {
            _cash_dispenser_image.setImage(_Activate_cash_dispenser);
            _current_state.setText(_atm.async_current_state());
        });
        try {
            Thread.sleep(2000L);
        } catch (InterruptedException ie) {
        }
        javafx.application.Platform.runLater(() -> {
            _cash_dispenser_image.setImage(_Any_device);
        });
    }

    public void activate_deposit_drawer() {
        javafx.application.Platform.runLater(() -> {
            _deposit_drawer_image.setImage(_Activate_deposit_drawer);
            _current_state.setText(_atm.async_current_state());
        });
        try {
            Thread.sleep(2000L);
        } catch (InterruptedException ie) {
        }
        javafx.application.Platform.runLater(() -> {
            _deposit_drawer_image.setImage(_Any_device);
        });
    }

    public void activate_receipt_printer() {
        new javafx.scene.media.MediaPlayer(_Deliver_receipt).play();
        javafx.application.Platform.runLater(() -> {
            _receipt_printer_image.setImage(_Activate_receipt_printer);
            _current_state.setText(_atm.async_current_state());
        });
        try {
            Thread.sleep(2000L);
        } catch (InterruptedException ie) {
        }
        javafx.application.Platform.runLater(() -> {
            _receipt_printer_image.setImage(_Any_device);
        });
    }

    public void display_account() {
        javafx.application.Platform.runLater(() -> {
            switch (_atm._operation_kind) {
                case Operation.Deposit:
                    _display_area.setText("Deposit(" + _atm._account.unique() + "):\n" + _atm._amount);
                    break;
                case Operation.Query:
                    _display_area.setText("Query(" + _atm._account.unique() + "):\n" + _atm._account.balance());
                    break;
                case Operation.Transfer:
                    _display_area.setText("Transfer(" + _atm._account.unique() + "\n->" + _atm._transfer_account.unique() + "): " + _atm._amount);
                    break;
                case Operation.Withdrawal:
                    _display_area.setText("Withdrawal(" + _atm._account.unique() + "):\n" + _atm._amount);
                    break;
            }
            _current_state.setText(_atm.async_current_state());
        });
    }

    @javafx.fxml.FXML
    public void display_card_put_down() {
        javafx.application.Platform.runLater(() -> {
            _card_taken_button.setDisable(true);
            _display_area.setText("Card put down\n");
            _current_state.setText(_atm.async_current_state());
        });
        try {
            Thread.sleep(2000L);
        } catch (InterruptedException ie) {
        }
    }

    @javafx.fxml.FXML
    public void display_card_unreadable() {
        javafx.application.Platform.runLater(() -> {
            _display_area.setText("Card unreadable\n");
            _current_state.setText(_atm.async_current_state());
        });
    }

    @javafx.fxml.FXML
    public void display_choose_account() {
        javafx.application.Platform.runLater(() -> {
            _display_area.setText("Choose account (" + Operation._Literals[_atm._operation_kind] + ")\n");
            for (int i = 0; i < _atm._portfolio.account().toArray().length; i++) {
                _display_area.setText(_display_area.getText() + i + ".: " + ((com.FranckBarbier.Java._Banking_system._Consortium.Account) _atm._portfolio.account().toArray()[i]).unique() + "\n");
            }
            _current_state.setText(_atm.async_current_state());
        });
    }

    public void display_choose_amount() {
        _amount.delete(0, _Amount_length);
        javafx.application.Platform.runLater(() -> {
            _display_area.setText("Choose amount\n");
            _current_state.setText(_atm.async_current_state());
        });
    }

    public void display_choose_continuation_or_termination() {
        javafx.application.Platform.runLater(() -> {
            _display_area.setText("Choose continuation or termination\n");
            _current_state.setText(_atm.async_current_state());
        });
    }

    public void display_choose_operation_kind() {
        javafx.application.Platform.runLater(() -> {
            _display_area.setText("Choose operation kind\n" + _Choose_operation_kind);
            _current_state.setText(_atm.async_current_state());
        });
    }

    public void display_enter_password() {
        _password.delete(0, _Password_length);
        javafx.application.Platform.runLater(() -> {
            _display_area.setText("Enter password\n");
            _current_state.setText(_atm.async_current_state());
        });
    }

    public void display_insert_card() {
        javafx.application.Platform.runLater(() -> {
            _card_taken_button.setDisable(true);
            _progress_indicator.setVisible(false);
            _card_inserted_button.setBackground(_Card_outside);
            _card_inserted_button.setDisable(false);
            _display_area.setText("Insert card\n");
            _current_state.setText(_atm.async_current_state());
        });
    }

    public void display_invalid_password() {
        javafx.application.Platform.runLater(() -> {
            _display_area.setText("Invalid password\n");
            _current_state.setText(_atm.async_current_state());
        });
    }

    public void display_operation_error(String text) {
        javafx.application.Platform.runLater(() -> {
            _display_area.setText("Operation error: " + text + "\n");
            _current_state.setText(_atm.async_current_state());
        });
    }

    public void display_operation_starts_() {
        javafx.application.Platform.runLater(() -> {
            _display_area.setText("Operation starts...\n");
            _current_state.setText(_atm.async_current_state());
        });
    }

    public void display_out_of_order() {
        javafx.application.Platform.runLater(() -> {
            _display_area.setText("Out of order\n");
            _current_state.setText(_atm.async_current_state());
        });
    }

    public void display_take_card() {
        javafx.application.Platform.runLater(() -> {
            _card_taken_button.setDisable(false);
            _progress_indicator.setVisible(false);
            _display_area.setText("Take card\n");
            _current_state.setText(_atm.async_current_state());
        });
    }

    public void display_transaction_error(String text) {
        javafx.application.Platform.runLater(() -> {
            _display_area.setText("Transaction error: " + text + "\n");
            _current_state.setText(_atm.async_current_state());
        });
    }

    public void display_transaction_starts_() {
        javafx.application.Platform.runLater(() -> {
            _display_area.setText("Transaction starts...\n");
            _current_state.setText(_atm.async_current_state());
        });
    }
}
