package com.FranckBarbier.Java._Banking_system._Consortium;

public class Banking_system_database {

    static {
        try {
            java.sql.DriverManager.registerDriver(new org.apache.derby.jdbc.EmbeddedDriver());
            java.sql.Statement statement = java.sql.DriverManager.getConnection("jdbc:derby:Banking_system_database;create=true").createStatement();
            statement.execute("create table Client(\n"
                    + "bank_code varchar(10),\n"
                    + "client_PIN varchar(10),\n"
                    + "name varchar(100),\n"
                    + "address varchar(100),\n"
                    + "constraint Client_key primary key(bank_code,client_PIN))");
            statement.execute("create table Logical_card(\n"
                    + "card_number varchar(10),\n"
                    + "password varchar(4),\n"
                    + "withdrawal_weekly_limit integer,\n"
                    + "bank_code varchar(10) not null,\n"
                    + "client_PIN varchar(10) not null,\n"
                    + "constraint Logical_card_key primary key(card_number),\n"
                    + "constraint Logical_card_unique unique(bank_code,client_PIN),\n"
                    + "constraint Client_foreign_key foreign key(bank_code,client_PIN) references Client(bank_code,client_PIN))");
            statement.execute("create table Plastic_card(\n"
                    + "serial_number varchar(10),\n"
                    + "card_number varchar(10) not null,\n"
                    + "constraint Plastic_card_key primary key(serial_number),\n"
                    + "constraint Logical_card_foreign_key foreign key(card_number) references Logical_card(card_number))");
            statement.execute("create table Accessibility(\n"
                    + "bank_code varchar(10),\n"
                    + "account_number varchar(10),\n"
                    + "card_number varchar(10) not null,\n"
                    + "constraint Accessibility_key primary key(bank_code,account_number),\n"
                    + "constraint Logical_card_foreign_key2 foreign key(card_number) references Logical_card(card_number))");
            statement.execute("create table Default_account(\n"
                    + "bank_code varchar(10),\n"
                    + "account_number varchar(10),\n"
                    + "card_number varchar(10) not null,\n"
                    + "constraint Default_account_key primary key(bank_code,account_number),\n"
                    + "constraint Default_account_unique unique(card_number),\n"
                    + "constraint Accessibility_foreign_key foreign key(bank_code,account_number) references Accessibility(bank_code,account_number) on delete cascade,\n"
                    + "constraint Logical_card_foreign_key3 foreign key(card_number) references Logical_card(card_number) on delete cascade)");
            statement.execute("insert into Client values('B1','11-01-1963','Franck Barbier','www.PauWare.com')");
            statement.execute("insert into Client values('B1','06-12-1993','Oscar Barbier--Darnal','www.PauWare.com')");
            statement.execute("insert into Client values('B2','15-04-1996','Lena Barbier--Darnal','www.PauWare.com')");
            statement.execute("insert into Client values('B1','22-02-2001','Joseph Barbier--Darnal','www.PauWare.com')");
            statement.execute("insert into Logical_card values('LC FB','1101',3000,'B1','11-01-1963')");
            statement.execute("insert into Logical_card values('LC OBD','0612',1000,'B1','06-12-1993')");
            statement.execute("insert into Logical_card values('LC LBD','1504',1000,'B2','15-04-1996')");
            statement.execute("insert into Logical_card values('LC JBD','2202',1000,'B1','22-02-2001')");
            statement.execute("insert into Plastic_card values('PC1 FB','LC FB')");
            statement.execute("insert into Plastic_card values('PC2 FB','LC FB')");
            statement.execute("insert into Plastic_card values('PC OBD','LC OBD')");
            statement.execute("insert into Plastic_card values('PC LBD','LC LBD')");
            statement.execute("insert into Plastic_card values('PC JBD','LC JBD')");
            statement.execute("insert into Accessibility values('B1','0000000001','LC FB')");
            statement.execute("insert into Accessibility values('B1','0000000002','LC FB')");
            statement.execute("insert into Accessibility values('B1','0000000003','LC OBD')");
            statement.execute("insert into Accessibility values('B2','0000000001','LC LBD')");
            statement.execute("insert into Accessibility values('B1','0000000004','LC JBD')");
            statement.execute("insert into Default_account values('B1','0000000001','LC FB')");
            statement.execute("insert into Default_account values('B1','0000000003','LC OBD')");
            statement.execute("insert into Default_account values('B2','0000000001','LC LBD')");
            statement.execute("insert into Default_account values('B1','0000000004','LC JBD')");

            statement.execute("create table ATM(station_code varchar(10),\n"
                    + "constraint ATM_key primary key(station_code))");
            statement.execute("create table GonyVA(station_code varchar(10),\n"
                    + "                    serial_number varchar(10),\n"
                    + "                    authorisation_date date,\n"
                    + "constraint GonyVA_key primary key(station_code),\n"
                    + "constraint GonyVA_unique unique(serial_number),\n"
                    + "constraint ATM_foreign_key foreign key(station_code) references ATM(station_code),\n"
                    + "constraint Plastic_card_foreign_key foreign key(serial_number) references Plastic_card(serial_number))");
            statement.execute("create table GoaVA(station_code varchar(10),\n"
                    + "                   serial_number varchar(10),\n"
                    + "constraint GoaVA_key primary key(station_code),\n"
                    + "constraint GoaVA_unique unique(serial_number),\n"
                    + "constraint ATM_foreign_key2 foreign key(station_code) references ATM(station_code),\n"
                    + "constraint Plastic_card_foreign_key2 foreign key(serial_number) references Plastic_card(serial_number))");
            statement.execute("create table GonyPO(station_code varchar(10),\n"
                    + "                    serial_number varchar(10),\n"
                    + "                    operation varchar(100),\n"
                    + "                    operation_date date,\n"
                    + "constraint GonyPO_key primary key(station_code,serial_number,operation),\n"
                    + "constraint GoaVA_foreign_key foreign key(station_code) references GoaVA(station_code) on delete cascade,\n"
                    + "constraint GoaVA_foreign_key2 foreign key(serial_number) references GoaVA(serial_number) on delete cascade)");
            statement.execute("create table GoCO(station_code varchar(10),\n"
                    + "                  serial_number varchar(10),\n"
                    + "                  operation varchar(100),\n"
                    + "constraint GoCO_key primary key(station_code,serial_number,operation))");
            statement.execute("insert into ATM values('0000000001')");
        } catch (java.sql.SQLException sqle1) {
            System.err.println("'Banking_system_database' probably already exists? " + sqle1.getMessage());
            java.sql.Connection connection;
            java.sql.Statement clean_up;
            try {
                connection = java.sql.DriverManager.getConnection("jdbc:derby:Banking_system_database");
                clean_up = connection.createStatement();
                clean_up.execute("delete from GoCO");
                clean_up.execute("delete from GonyPO");
                clean_up.execute("delete from GoaVA");
                clean_up.execute("delete from GonyVA");
                connection.commit();
            } catch (java.sql.SQLException sqle2) {
                System.err.println("'Banking_system_database' persistent error: " + sqle2.getMessage());
                System.exit(-1);
            }
        }
    }

    private java.sql.Connection _connection;
    private java.sql.ResultSet _available_cards;

    public Banking_system_database() throws java.sql.SQLException {
        _connection = java.sql.DriverManager.getConnection("jdbc:derby:Banking_system_database");
        _connection.setAutoCommit(false);
        _available_cards = _connection.createStatement(java.sql.ResultSet.TYPE_SCROLL_INSENSITIVE, java.sql.ResultSet.CONCUR_READ_ONLY).executeQuery("SELECT DISTINCT PLASTIC_CARD.SERIAL_NUMBER, LOGICAL_CARD.CARD_NUMBER, CLIENT.BANK_CODE, CLIENT.NAME, CLIENT.CLIENT_PIN, LOGICAL_CARD.PASSWORD, LOGICAL_CARD.WITHDRAWAL_WEEKLY_LIMIT\n"
                + "FROM PLASTIC_CARD, CLIENT, LOGICAL_CARD\n"
                + "WHERE PLASTIC_CARD.CARD_NUMBER = LOGICAL_CARD.CARD_NUMBER\n"
                + "AND LOGICAL_CARD.CLIENT_PIN = CLIENT.CLIENT_PIN");
    }

    public java.sql.Connection activate_connection() throws Exception {
        if (_connection == null) {
            throw new Exception("Fatal error: JDBC not initialized");
        }
        return _connection;
    }

    public void disactivate_connection() throws Exception {
        if (_connection == null) {
            throw new Exception("Fatal error: JDBC not initialized");
        }
        _connection.commit();
        _connection.close();
    }

    public java.util.List<String> cards() throws Exception {
        java.util.List<String> cards = new java.util.ArrayList<>();
        _available_cards.beforeFirst();
        while (_available_cards.next()) {
            cards.add(String.format("%s@%s", _available_cards.getString("NAME"), _available_cards.getString("PASSWORD")));
        }
        return cards;
    }

    public Plastic_card card(String card) throws Exception {
        _available_cards.beforeFirst();
        while (_available_cards.next()) {
            if (card.substring(0, card.indexOf('@')).equals(_available_cards.getString("NAME")) && card.substring(card.indexOf('@') + 1, card.length()).equals(_available_cards.getString("PASSWORD"))) {
                return new Plastic_card(_available_cards.getString("SERIAL_NUMBER"), new Logical_card(_available_cards.getString("CARD_NUMBER"), new Client(_available_cards.getString("BANK_CODE"), _available_cards.getString("CLIENT_PIN")), _available_cards.getString("PASSWORD"), _available_cards.getInt("WITHDRAWAL_WEEKLY_LIMIT")));
            }
        }
        return null;
    }
}
